#include <iostream>
#include <cstdio>
#define MAXN 1024

using namespace std;

int n;
int ans[MAXN << 1];
char p1[MAXN], p2[MAXN];
char dp[MAXN][MAXN][3]; // 0 (number_of_0 = number_of_1), 
                        // 1 (number_of_0 - number_of_1 = -1), 
                        // 2 (number_of_0 - number_of_1 = 1)

int code(int k) {
    if(k == 0) return 0;
    if(k == -1) return 1;
    return 2;
    }

int encode(int k) {
    if(k == 0) return 0;
    if(k == 1) return -1;
    return 1;
    }

bool check(int nxt) {
     return (-1 <= nxt && nxt <= 1);
     }

void print() {
     int i = n, j = n, k = 0;
     int diff = 0, sz = 0;
     while(!(i == 0 && j == 0 && k == 0)) {
               ans[sz] = dp[i][j][k];
               
               if(ans[sz] == 1) diff -= p1[i - 1], i--;
               else diff -= p2[j - 1], j--;
               k = code(diff);
               
               sz++;
               }
     
     for(i=sz-1; i>=0; i--) printf("%d", ans[i]);
     printf("\n");
     }

int main() {
    scanf("%d", &n);
    scanf("%s%s", &p1, &p2);
    
    int i, j, k;
    int diff, nxt;
    
    for(i=0; i<n; i++)
    {
    if(p1[i] == '0') p1[i] = 1;
    else p1[i] = -1;   
    
    if(p2[i] == '0') p2[i] = 1;
    else p2[i] = -1;   
    }      
    
    dp[0][0][0] = 0;
 
    for(i=0; i<=n; i++)
    for(j=0; j<=n; j++)
    for(k=0; k<3; k++)
    if(dp[i][j][k] || (i == 0 && j == 0 && k == 0)) {
                    diff = encode(k);   
                    
                    nxt = diff + p1[i];
                    if(i < n && check(nxt)) dp[i + 1][j][code(nxt)] = 1;
                               
                    nxt = diff + p2[j];
                    if(j < n && check(nxt)) dp[i][j + 1][code(nxt)] = 2;
                    }
    
    print();
    return 0;
    }
