//     - 2013
// :  
// :  

#include <iostream>
#include <vector>
#include <cstdlib>
using namespace std;

const int m=4, n=5;
int a[m+1][n+1];

typedef pair<int,int> pos;

vector<pos> adj[m+1][n+1];

pos path[m*n+1];
int cnt;

void show()
{ cnt++;
  for(int i=1; i<=m; i++)
    for(int j=1; j<=n; j++)
      cout << a[i][j] << " ";
  cout << endl;
}

void go(int k)
{ int x=path[k-1].first;
  int y=path[k-1].second;

  for(auto t: adj[x][y])
  { int p=t.first;
    int q=t.second;
    if(a[p][q]==0)
    { a[p][q]=k;
      path[k]=pos(p,q);
      if(k==m*n) show();
      go(k+1);
      a[p][q]=0;
    }
  }
}

int main()
{ for(int i=1; i<=m; i++)
    for(int j=1; j<=n; j++)
      for(int i1=1; i1<=m; i1++)
        for(int j1=1; j1<=n; j1++)
          { int p = abs(i1-i);
            int q = abs(j1-j);
            if(p>0 && q>0 && p+q==3)
              adj[i][j].push_back(pos(i1,j1));
          }

  cnt = 0;
  for(int x=1; x<=m; x++)
    for(int y=1; y<=n; y++)
    { for(int i=1; i<=m; i++)
        for(int j=1; j<=n; j++)
          a[i][j]=0;

      a[x][y]=1;
      path[1]=pos(x,y);

      go(2);
    }
  cout << cnt << endl;

	return 0;
}

